#  Licensed to the Apache Software Foundation (ASF) under one
#  or more contributor license agreements.  See the NOTICE file
#  distributed with this work for additional information
#  regarding copyright ownership.  The ASF licenses this file
#  to you under the Apache License, Version 2.0 (the
#  "License"); you may not use this file except in compliance
#  with the License.  You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing,
#  software distributed under the License is distributed on an
#  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
#  KIND, either express or implied.  See the License for the
#  specific language governing permissions and limitations
#  under the License.

def getConfig():
    config = {'version': 'v1',
              'config': {'visState': {'filters': [],
                                      'layers': [{'id': 'ikzru0t',
                                                  'type': 'geojson',
                                                  'config': {'dataId': 'AirportCount',
                                                             'label': 'AirportCount',
                                                             'color': [218, 112, 191],
                                                             'highlightColor': [252, 242, 26, 255],
                                                             'columns': {'geojson': 'geometry'},
                                                             'isVisible': True,
                                                             'visConfig': {'opacity': 0.8,
                                                                           'strokeOpacity': 0.8,
                                                                           'thickness': 0.5,
                                                                           'strokeColor': [18, 92, 119],
                                                                           'colorRange': {'name': 'Uber Viz Sequential 6',
                                                                                          'type': 'sequential',
                                                                                          'category': 'Uber',
                                                                                          'colors': ['#E6FAFA',
                                                                                                     '#C1E5E6',
                                                                                                     '#9DD0D4',
                                                                                                     '#75BBC1',
                                                                                                     '#4BA7AF',
                                                                                                     '#00939C',
                                                                                                     '#108188',
                                                                                                     '#0E7077']},
                                                                           'strokeColorRange': {'name': 'Global Warming',
                                                                                                'type': 'sequential',
                                                                                                'category': 'Uber',
                                                                                                'colors': ['#5A1846',
                                                                                                           '#900C3F',
                                                                                                           '#C70039',
                                                                                                           '#E3611C',
                                                                                                           '#F1920E',
                                                                                                           '#FFC300']},
                                                                           'radius': 10,
                                                                           'sizeRange': [0, 10],
                                                                           'radiusRange': [0, 50],
                                                                           'heightRange': [0, 500],
                                                                           'elevationScale': 5,
                                                                           'enableElevationZoomFactor': True,
                                                                           'stroked': False,
                                                                           'filled': True,
                                                                           'enable3d': False,
                                                                           'wireframe': False},
                                                             'hidden': False,
                                                             'textLabel': [{'field': None,
                                                                            'color': [255, 255, 255],
                                                                            'size': 18,
                                                                            'offset': [0, 0],
                                                                            'anchor': 'start',
                                                                            'alignment': 'center'}]},
                                                  'visualChannels': {'colorField': {'name': 'AirportCount',
                                                                                    'type': 'integer'},
                                                                     'colorScale': 'quantize',
                                                                     'strokeColorField': None,
                                                                     'strokeColorScale': 'quantile',
                                                                     'sizeField': None,
                                                                     'sizeScale': 'linear',
                                                                     'heightField': None,
                                                                     'heightScale': 'linear',
                                                                     'radiusField': None,
                                                                     'radiusScale': 'linear'}}],
                                      'interactionConfig': {'tooltip': {'fieldsToShow': {'AirportCount': [{'name': 'NAME_EN',
                                                                                                           'format': None},
                                                                                                          {'name': 'AirportCount', 'format': None}]},
                                                                        'compareMode': False,
                                                                        'compareType': 'absolute',
                                                                        'enabled': True},
                                                            'brush': {'size': 0.5, 'enabled': False},
                                                            'geocoder': {'enabled': False},
                                                            'coordinate': {'enabled': False}},
                                      'layerBlending': 'normal',
                                      'splitMaps': [],
                                      'animationConfig': {'currentTime': None, 'speed': 1}},
                         'mapState': {'bearing': 0,
                                      'dragRotate': False,
                                      'latitude': 56.422456606624316,
                                      'longitude': 9.778836615231771,
                                      'pitch': 0,
                                      'zoom': 0.4214991225736964,
                                      'isSplit': False},
                         'mapStyle': {'styleType': 'dark',
                                      'topLayerGroups': {},
                                      'visibleLayerGroups': {'label': True,
                                                             'road': True,
                                                             'border': False,
                                                             'building': True,
                                                             'water': True,
                                                             'land': True,
                                                             '3d building': False},
                                      'threeDBuildingColor': [9.665468314072013,
                                                              17.18305478057247,
                                                              31.1442867897876],
                                      'mapStyles': {}}}}
    return config
